package jfd.exp;

public class AssignmentNode extends Node
{
   private Node lvalue = null;
   private Node rvalue = null;

   public AssignmentNode(Node lvalue, Node rvalue)
   {
      this.lvalue = lvalue;
      this.rvalue = rvalue;
   }

   public void accept(Visitor v)
   {
      v.visited(this);
   }

   public String toString()
   {
      return(lvalue + " = " + rvalue);
   }

   public double execute(
      SymbolTable table
   )
      throws Exception
   {
      String name = lvalue.toVariable();

      if(name == null)
      {
         throw new Exception(
            "Not an lvalue: [" + lvalue + "]"
         );
      }
      double result = rvalue.execute(table);
      table.setValue(name, result);

      return(result);
   }
}
