package jfd.exp;

public class BinaryNode extends Node
{
   private Node left     = null;
   private char operator = '\0';
   private Node right    = null;

   public BinaryNode(Node left, char operator, Node right)
   {
      this.left     = left;
      this.operator = operator;
      this.right    = right;
   }

   public void accept(Visitor v)
   {
      v.visited(this);
      left.accept(v);
      right.accept(v);
   }

   public String toString()
   {
      return(left + " " + operator + " " + right);
   }

   public double execute(
      SymbolTable table
   )
      throws Exception
   {
      double value1 = left.execute(table);
      double value2 = right.execute(table);

      switch(operator)
      {
         case '+': value1 += value2; break;
         case '-': value1 -= value2; break;
         case '*': value1 *= value2; break;
         case '/': value1 /= value2; break;
      }

      return(value1);
   }
}
